from ngsolve import *
from netgen.csg import *
import netgen.gui

# ***************************************************
# Generate geometry for a unit cube
# ***************************************************
def Geom_Cube():
   geo_cube = CSGeometry()
   left  = Plane (Pnt(0,0,0), Vec(-1,0,0) ).bc("left")
   right = Plane (Pnt(1,1,1), Vec( 1,0,0) ).bc("right")
   front = Plane (Pnt(0,0,0), Vec(0,-1,0) ).bc("front")
   back  = Plane (Pnt(1,1,1), Vec(0, 1,0) ).bc("back")
   bot   = Plane (Pnt(0,0,0), Vec(0,0,-1) ).bc("bot")
   top   = Plane (Pnt(1,1,1), Vec(0,0, 1) ).bc("top")
   
   cube = left * right * front * back * bot * top
   geo_cube.Add (cube)
   #geo.Draw()
   return geo_cube
   
ngmesh = Geom_Cube().GenerateMesh(maxh=0.1)
#ngmesh.Save("cube.vol")
mesh=Mesh(ngmesh)

from math import pi
uex = (1-y)*sin(pi*x)
# grad_uex = CoefficientFunction((pi*(1-y)*cos(pi*x), -sin(pi*x)))


fesp = H1(mesh, order=2)
# L2 Projection of exact solution onto the mesh
gfuex = GridFunction(fesp, "u-exact")
gfuex.Set(uex)
Draw(gfuex, mesh, "uexact")
